/* 
   Copyright (C) 2006 Luke Sandell <lasandell@gmail.com>

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License version 2 as published by the Free Software Foundation.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public License
   along with this library; see the file COPYING.LIB.  If not, write to
   the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.
*/

#include <kio/slavebase.h>
#include <kstandarddirs.h>
#include <qcstring.h>
#include <kurl.h>

struct ResourceInfo;

class ResourcesProtocol : public KIO::SlaveBase
{
public:
   ResourcesProtocol( const QCString &pool, const QCString &app );
   virtual void put( const KURL& url, int permissions, bool overwrite, bool resume ); 
   virtual void get( const KURL & url );
   virtual void stat( const KURL & url );
   virtual void listDir( const KURL & url );
   virtual void del( const KURL & url, bool isFile );
   virtual void mkdir( const KURL &url, int permissions );
   virtual void rename( const KURL & src, const KURL & dest, bool overwrite );
private:
   bool decodeURL( const KURL & url, ResourceInfo & info );

   KStandardDirs *m_dirs;
};
